{% extends '@!EasyAdmin/default/list.html.twig' %}
{% block global_actions %}
    {{ parent() }}
    <style>
        tr.bg-success:hover td {
            background-color: #1ea471 !important;
        }
    </style>
    <div class="button-action">
        <a class="btn btn-primary update" href="{{ path('loadOrders') }}">Load orders</a>
    </div>
    <div class="button-action">
        <a class="btn btn-primary update" href="{{ path('updateAllOrders') }}">Update all orders</a>
    </div>

{% endblock %}
{% block body_javascript %}
    {{ parent() }}

    <script src="{{ asset('assets/js/functions/ajax.js') }}"></script>
    <script type="text/javascript">
        let carriers;

        const getCarriersAndStates = (() => {

            window.onload = function () {

                ajax('GET', null, "{{ path("get_carriers") }}", null, data => {
                    carriers = JSON.parse(data);
                    getCarriers();
                });

                ajax('GET', null, "{{ path("get_states") }}", null, data => {
                    states = JSON.parse(data);
                    getAllStates()
                })
            };
        })();

        let states;

        const getAllStates = () => {
            const order_states_select = document.querySelectorAll('.order_states_select');
            order_states_select.forEach(item => {
                for (let stateInd in states) {
                    let selected = states[stateInd].id == item.dataset.currentstate ? 'selected' : '';
                    let html = `<option style="background-color: ${states[stateInd].color}" value="${states[stateInd].id}" ${selected}> ${states[stateInd].name}</option>`;
                    item.innerHTML += html;
                }
                item.addEventListener('change', (e) => {
                    ajax('GET', null, `updateOrderState/${item.dataset.order}/${e.target.value}`, null, data => {
                        item.setAttribute('style', 'background-color:' + data);
                    });
                });
            });
        };

        const getCarriers = () => {
            let selects = document.querySelectorAll('.carrier_select');
            [...selects].forEach((select) => {
                for (let carrierIND in carriers) {
                    console.log(select.dataset.value);
                    let selected = carriers[carrierIND].id == select.dataset.value ? 'selected' : '';
                    let html = '<option value="' + carriers[carrierIND].id + '" ' + selected + ' >' + carriers[carrierIND].name + '</option>';
                    select.innerHTML += html;
                }
                select.addEventListener('change', (event) => {
                    ajax('GET', null, 'updateOrderCarrier/' + event.target.dataset.order_id + '/' + event.target.value, null, data => console.log('Success'));
                });
            });
        };

        const moveProductTableToDown = (() => {
            let virtual = document.querySelector('.virtual.text');
            if (virtual) virtual.remove();

            document.querySelectorAll('.orderInPrp').forEach(async item => {
                const row = item.parentElement.parentElement;
                let td = item.parentElement;
                console.log(td);
                const childRows = [...item.getElementsByTagName('TR')];
                childRows[childRows.length - 1].style.border = '2px solid black;';
                await childRows.reverse().forEach(tr => {
                    row.after(tr);
                })
                await td.remove()
            });
        })();

        const checkIsValidated = (() => {
            document.querySelectorAll('.is_validated').forEach(item => {
                item.addEventListener('change', e => {
                    const orderProductId = e.target.dataset.orderproduct;
                    ajax('get', null, `/prestashop_order/change_product_validate/${orderProductId}/${item.checked}`, null, res => {
                        const isValidatedTr = item.closest('.isValidatedTr');
                        if (res == 0) {
                            isValidatedTr.classList.remove('bg-success');
                        } else {
                            isValidatedTr.classList.add('bg-success');
                        }
                    })
                });
            });
        })();

        const giveColorsToIds = (() => {
            document.querySelectorAll('.order-id').forEach(item => {
                item.parentNode.style.background = item.dataset.color
            });
        })();

        const changeOrderWeight = (() => {
            document.querySelectorAll('.order_weight_input').forEach(item => {
                item.addEventListener('change', e => {
                    const id = e.target.dataset.id;
                    const value = e.target.value;
                    ajax('GET', null, '/admin/updateOrderWeight/' + id + '/' + value, null, res => console.log('Success'));
                });
            });
        })();


    </script>

{% endblock %}